git-am.sh 12.2 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5
SUBDIRECTORY_OK=Yes
6 7
OPTIONS_KEEPDASHDASH=
OPTIONS_SPEC="\
J
Junio C Hamano 已提交
8
git am [options] [<mbox>|<Maildir>...]
9
git am [options] (--resolved | --skip | --abort)
10
--
11
d,dotest=       (removed -- do not use)
12
i,interactive   run interactively
S
Stephan Beyer 已提交
13
b,binary        (historical option -- no-op)
14 15 16
3,3way          allow fall back on 3way merging if needed
s,signoff       add a Signed-off-by line to the commit message
u,utf8          recode into utf8 (default)
17
k,keep          pass -k flag to git-mailinfo
18 19 20 21 22
whitespace=     pass it through git-apply
C=              pass it through git-apply
p=              pass it through git-apply
resolvemsg=     override error message when patch failure occurs
r,resolved      to be used after a patch failure
J
Junio C Hamano 已提交
23
skip            skip the current patch
N
Nanako Shiraishi 已提交
24
abort           restore the original branch and abort the patching operation.
J
Junio C Hamano 已提交
25
rebasing        (internal use for git-rebase)"
26

27
. git-sh-setup
28
prefix=$(git rev-parse --show-prefix)
29
set_reflog_action am
30
require_work_tree
31
cd_to_toplevel
32

33 34
git var GIT_COMMITTER_IDENT >/dev/null ||
	die "You need to set your committer info first"
35

36 37 38 39 40
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

41
stop_here_user_resolve () {
42
    if [ -n "$resolvemsg" ]; then
J
Jeff King 已提交
43
	    printf '%s\n' "$resolvemsg"
44 45
	    stop_here $1
    fi
46
    cmdline="git am"
47 48 49 50 51 52 53 54 55 56
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
N
Nanako Shiraishi 已提交
57
    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
58 59 60 61

    stop_here $1
}

62 63 64 65 66 67 68
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

69 70 71 72 73 74
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

75 76 77 78 79 80 81
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
82 83
    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
	"$dotest/patch" &&
84
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
85
    git write-tree >"$dotest/patch-merge-base+" ||
86
    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
87 88 89

    echo Using index info to reconstruct a base tree...
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
S
Stephan Beyer 已提交
90
	git apply --cached <"$dotest/patch"
91 92 93
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
94 95 96
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
97 98 99
    fi

    test -f "$dotest/patch-merge-index" &&
100
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
101 102 103 104 105 106 107 108
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

    echo Falling back to patching base and 3-way merge...

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
109
    # patch did not touch, so recursive ends up canceling them,
110 111
    # saying that we reverted all those changes.

112
    eval GITHEAD_$his_tree='"$FIRSTLINE"'
113 114
    export GITHEAD_$his_tree
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
115
	    git rerere
116 117 118
	    echo Failed to merge in the changes.
	    exit 1
    }
119
    unset GITHEAD_$his_tree
120 121 122
}

prec=4
123
dotest="$GIT_DIR/rebase-apply"
S
Stephan Beyer 已提交
124
sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
125
resolvemsg= resume=
M
Michael S. Tsirkin 已提交
126
git_apply_opt=
127

128
while test $# != 0
129 130
do
	case "$1" in
131 132 133
	-i|--interactive)
		interactive=t ;;
	-b|--binary)
S
Stephan Beyer 已提交
134
		: ;;
135 136
	-3|--3way)
		threeway=t ;;
137
	-s|--signoff)
138 139 140 141 142 143 144 145 146 147 148
		sign=t ;;
	-u|--utf8)
		utf8=t ;; # this is now default
	--no-utf8)
		utf8= ;;
	-k|--keep)
		keep=t ;;
	-r|--resolved)
		resolved=t ;;
	--skip)
		skip=t ;;
N
Nanako Shiraishi 已提交
149 150
	--abort)
		abort=t ;;
J
Junio C Hamano 已提交
151
	--rebasing)
S
Stephan Beyer 已提交
152
		rebasing=t threeway=t keep=t ;;
153
	-d|--dotest)
154 155
		die "-d option is no longer supported.  Do not use."
		;;
156 157 158 159 160 161
	--resolvemsg)
		shift; resolvemsg=$1 ;;
	--whitespace)
		git_apply_opt="$git_apply_opt $1=$2"; shift ;;
	-C|-p)
		git_apply_opt="$git_apply_opt $1$2"; shift ;;
162
	--)
163
		shift; break ;;
164
	*)
165
		usage ;;
166
	esac
167
	shift
168 169
done

J
Junio C Hamano 已提交
170 171
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
172 173 174 175 176 177 178 179 180 181 182
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
N
Nanako Shiraishi 已提交
183
	case "$#,$skip$resolved$abort" in
J
Junio C Hamano 已提交
184 185 186 187 188 189 190
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
191
		# when there is already $dotest.  This is somewhat
J
Junio C Hamano 已提交
192 193 194 195 196 197 198 199 200
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
		tty -s
		;;
	*)
		false
		;;
	esac ||
201
	die "previous rebase directory $dotest still exists but mbox given."
202
	resume=yes
N
Nanako Shiraishi 已提交
203

204 205 206 207 208 209 210 211 212
	case "$skip,$abort" in
	t,)
		git rerere clear
		git read-tree --reset -u HEAD HEAD
		orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
		git reset HEAD
		git update-ref ORIG_HEAD $orig_head
		;;
	,t)
N
Nanako Shiraishi 已提交
213 214 215 216 217 218
		git rerere clear
		git read-tree --reset -u HEAD ORIG_HEAD
		git reset ORIG_HEAD
		rm -fr "$dotest"
		exit ;;
	esac
219
else
N
Nanako Shiraishi 已提交
220 221
	# Make sure we are not given --skip, --resolved, nor --abort
	test "$skip$resolved$abort" = "" ||
222
		die "Resolve operation not in progress, we are not resuming."
223 224 225 226

	# Start afresh.
	mkdir -p "$dotest" || exit

227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244
	if test -n "$prefix" && test $# != 0
	then
		first=t
		for arg
		do
			test -n "$first" && {
				set x
				first=
			}
			case "$arg" in
			/*)
				set "$@" "$arg" ;;
			*)
				set "$@" "$prefix$arg" ;;
			esac
		done
		shift
	fi
245
	git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
246 247 248 249
		rm -fr "$dotest"
		exit 1
	}

S
Stephan Beyer 已提交
250
	# -s, -u, -k and --whitespace flags are kept for the
J
Junio C Hamano 已提交
251
	# resuming session after a patch failure.
J
Junio C Hamano 已提交
252
	# -3 and -i can and must be given when resuming.
J
Junio C Hamano 已提交
253
	echo " $ws" >"$dotest/whitespace"
254 255 256 257
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
	echo 1 >"$dotest/next"
J
Junio C Hamano 已提交
258 259 260 261 262
	if test -n "$rebasing"
	then
		: >"$dotest/rebasing"
	else
		: >"$dotest/applying"
263
		git update-ref ORIG_HEAD HEAD
J
Junio C Hamano 已提交
264
	fi
265 266
fi

J
Junio C Hamano 已提交
267 268
case "$resolved" in
'')
269
	files=$(git diff-index --cached --name-only HEAD --) || exit
J
Junio C Hamano 已提交
270 271 272 273 274 275
	if [ "$files" ]; then
	   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
	   exit 1
	fi
esac

276 277 278
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
279 280
else
	utf8=-n
281 282 283 284 285
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
J
Junio C Hamano 已提交
286
ws=`cat "$dotest/whitespace"`
287 288
if test "$(cat "$dotest/sign")" = t
then
289
	SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
290 291 292 293 294 295 296 297 298 299 300 301
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
302
	resume=
303 304 305 306 307 308 309 310 311 312 313 314 315 316
fi

if test "$this" -gt "$last"
then
	echo Nothing to do.
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
317
		resume=
318 319 320
		go_next
		continue
	}
J
Junio C Hamano 已提交
321 322 323 324 325 326 327 328 329

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
330 331
	case "$resume" in
	'')
332
		git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
333 334
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
335 336 337 338 339 340

		# skip pine's internal folder data
		grep '^Author: Mail System Internal Data$' \
			<"$dotest"/info >/dev/null &&
			go_next && continue

341
		test -s "$dotest/patch" || {
342
			echo "Patch is empty.  Was it split wrong?"
343 344
			stop_here $this
		}
345 346 347 348 349 350 351 352 353 354 355
		if test -f "$dotest/rebasing" &&
			commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
				-e q "$dotest/$msgnum") &&
			test "$(git cat-file -t "$commit")" = commit
		then
			git cat-file commit "$commit" |
			sed -e '1,/^$/d' >"$dotest/msg-clean"
		else
			SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
			case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac

356
			(printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
357 358
				git stripspace > "$dotest/msg-clean"
		fi
359 360
		;;
	esac
361 362 363 364

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
365

366
	if test -z "$GIT_AUTHOR_EMAIL"
367
	then
368
		echo "Patch does not have a valid e-mail address."
369 370 371
		stop_here $this
	fi

J
Junio C Hamano 已提交
372
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
373

374 375 376 377
	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
378
		LAST_SIGNED_OFF_BY=`
379 380
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
381
		    sed -ne '$p'
382
		`
383 384
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
385 386
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
387 388
		}`
	    else
389
		ADD_SIGNOFF=
390 391
	    fi
	    {
392 393 394 395 396 397 398 399
		if test -s "$dotest/msg-clean"
		then
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
400 401
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
402
	*)
403
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
404 405
		tt)
			# This is used only for interactive view option.
406
			git diff-index -p --cached HEAD -- >"$dotest/patch"
J
Junio C Hamano 已提交
407 408
			;;
		esac
409
	esac
410

411
	resume=
412 413
	if test "$interactive" = t
	then
414 415
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
416 417 418 419 420 421 422
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
423
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
424 425
		read reply
		case "$reply" in
426 427 428
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
429
		[eE]*) git_editor "$dotest/final-commit"
430
		       action=again ;;
431 432 433
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
434 435 436 437 438
		esac
	    done
	else
	    action=yes
	fi
439
	FIRSTLINE=$(sed 1q "$dotest/final-commit")
440 441 442 443 444 445 446 447 448 449 450 451 452

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

453
	printf 'Applying: %s\n' "$FIRSTLINE"
454

J
Junio C Hamano 已提交
455 456
	case "$resolved" in
	'')
S
Stephan Beyer 已提交
457
		git apply $git_apply_opt --index "$dotest/patch"
J
Junio C Hamano 已提交
458 459 460 461 462 463 464 465
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
466
		git diff-index --quiet --cached HEAD -- && {
467
			echo "No changes - did you forget to use 'git add'?"
468
			stop_here_user_resolve $this
469
		}
470
		unmerged=$(git ls-files -u)
471 472 473
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
474
			echo "did you forget to use 'git add'?"
475
			stop_here_user_resolve $this
476
		fi
J
Junio C Hamano 已提交
477
		apply_status=0
478
		git rerere
J
Junio C Hamano 已提交
479 480 481
		;;
	esac

482 483
	if test $apply_status = 1 && test "$threeway" = t
	then
484
		if (fall_back_3way)
485
		then
486 487
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
488
		    git diff-index --quiet --cached HEAD -- && {
489 490 491 492
			echo No changes -- Patch already applied.
			go_next
			continue
		    }
493 494
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
495 496 497 498 499
		fi
	fi
	if test $apply_status != 0
	then
		echo Patch failed at $msgnum.
500
		stop_here_user_resolve $this
501 502 503 504 505 506 507
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

508 509 510
	tree=$(git write-tree) &&
	parent=$(git rev-parse --verify HEAD) &&
	commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
511
	git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
512 513 514 515 516 517 518 519 520 521
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

522 523
git gc --auto

524
rm -fr "$dotest"